package com.hotwj.platform.driverManagement.driverProfCert.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.driverManagement.driverProfCert.domain.HotDriverProfCert;
import com.hotwj.platform.driverManagement.driverProfCert.domain.bo.HotDriverProfCertBo;
import com.hotwj.platform.driverManagement.driverProfCert.domain.vo.HotDriverProfCertVo;
import com.hotwj.platform.driverManagement.driverProfCert.mapper.HotDriverProfCertMapper;
import com.hotwj.platform.driverManagement.driverProfCert.service.IHotDriverProfCertService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 从业资格证Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-15
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotDriverProfCertServiceImpl implements IHotDriverProfCertService {

    private final HotDriverProfCertMapper baseMapper;

    /**
     * 查询从业资格证
     *
     * @param id 主键
     * @return 从业资格证
     */
    @Override
    public HotDriverProfCertVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询从业资格证列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 从业资格证分页列表
     */
    @Override
    public TableDataInfo<HotDriverProfCertVo> queryPageList(HotDriverProfCertBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotDriverProfCert> lqw = buildQueryWrapper(bo);
        Page<HotDriverProfCertVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的从业资格证列表
     *
     * @param bo 查询条件
     * @return 从业资格证列表
     */
    @Override
    public List<HotDriverProfCertVo> queryList(HotDriverProfCertBo bo) {
        LambdaQueryWrapper<HotDriverProfCert> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotDriverProfCert> buildQueryWrapper(HotDriverProfCertBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotDriverProfCert> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotDriverProfCert::getId);
        lqw.eq(bo.getCompanyId() != null, HotDriverProfCert::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getDriverId() != null, HotDriverProfCert::getDriverId, bo.getDriverId());
        lqw.eq(StringUtils.isNotBlank(bo.getCategory()), HotDriverProfCert::getCategory, bo.getCategory());
        lqw.eq(StringUtils.isNotBlank(bo.getCertNo()), HotDriverProfCert::getCertNo, bo.getCertNo());
        lqw.eq(bo.getFirstIssueDate() != null, HotDriverProfCert::getFirstIssueDate, bo.getFirstIssueDate());
        lqw.eq(bo.getValidFrom() != null, HotDriverProfCert::getValidFrom, bo.getValidFrom());
        lqw.eq(bo.getValidTo() != null, HotDriverProfCert::getValidTo, bo.getValidTo());
        lqw.eq(StringUtils.isNotBlank(bo.getValidityTerm()), HotDriverProfCert::getValidityTerm, bo.getValidityTerm());
        lqw.eq(StringUtils.isNotBlank(bo.getIssuingAuthority()), HotDriverProfCert::getIssuingAuthority, bo.getIssuingAuthority());
        lqw.eq(StringUtils.isNotBlank(bo.getAttachmentUrl()), HotDriverProfCert::getAttachmentUrl, bo.getAttachmentUrl());
        lqw.eq(bo.getStatus() != null, HotDriverProfCert::getStatus, bo.getStatus());
        lqw.eq(bo.getIsDeleted() != null, HotDriverProfCert::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增从业资格证
     *
     * @param bo 从业资格证
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotDriverProfCertBo bo) {
        HotDriverProfCert add = MapstructUtils.convert(bo, HotDriverProfCert.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改从业资格证
     *
     * @param bo 从业资格证
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotDriverProfCertBo bo) {
        HotDriverProfCert update = MapstructUtils.convert(bo, HotDriverProfCert.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotDriverProfCert entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除从业资格证信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
